﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinDock;
using mshtml;

using Infragistics.Win;

namespace WindowsFormsApplication5
{
    public partial class Form1 : Form
    {
        private DockableControlPane pane1;
        private DockableControlPane pane2;

        private DockAreaPane aPane1;
        private DockAreaPane aPane2;

        private WebBrowser browser;

        private Panel p = new Panel();

        private bool bBrowser = false;

        public Form1()
        {
            InitializeComponent();

            

        }

        private void Form1_Load(object sender, EventArgs e)
        {

            if (!bBrowser == true)
            {
                ultraLabel1 = new Infragistics.Win.Misc.UltraLabel();
                ultraLabel1.Height = 50;
                ultraLabel1.Width = 300;
                ultraLabel1.Text = "This is a TEST";
                ultraLabel1.Dock = DockStyle.Top;
                pane1 = new DockableControlPane(ultraLabel1);               
            }
            else
            {
                browser = new WebBrowser();
                browser.Dock = DockStyle.Top;
                pane1 = new DockableControlPane(browser);
            }
                      

            aPane1 = new DockAreaPane(DockedLocation.DockedLeft);
            aPane1.Panes.Add(pane1);
            ultraDockManager1.ControlPanes.Add(pane1);

            var textBox = new TextBox { Dock = DockStyle.Top }; 
            ultraButtonPin.Dock = DockStyle.Top;
            ultraButtonClose.Dock = DockStyle.Top;
            ultraButtonShow.Dock = DockStyle.Top;
          
            p = new Panel();
            p.Controls.Add(textBox);
            p.Controls.Add(ultraButtonPin);
            p.Controls.Add(ultraButtonClose);
            p.Controls.Add(ultraButtonShow);
            

            pane2 = new DockableControlPane(p);
            aPane2 = new DockAreaPane(DockedLocation.DockedRight);
            aPane2.Panes.Add(pane2);
            ultraDockManager1.ControlPanes.Add(pane2);

            ultraDockManager1.DockAreas.AddRange(new[]
                                                     {
                                                         aPane1, aPane2
                                                     });

            System.Diagnostics.Debug.WriteLine("Form_Load");
           
        }

        protected override void OnShown(EventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("OnShown");
            base.OnShown(e);

            if (bBrowser)
            {
                var file = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location) + "/baseMap.htm";
                browser.Navigate(file);
            }
                        
        }

        private void ultraButtonPin_Click(object sender, EventArgs e)
        {

            if (bBrowser)
            {
                try
                {

                    System.Diagnostics.Debug.WriteLine("ultraButtonPin_Click");
                    HtmlElement head = browser.Document.GetElementsByTagName("head")[0];
                    HtmlElement scriptEl = browser.Document.CreateElement("script");
                    IHTMLScriptElement element = scriptEl.DomElement as IHTMLScriptElement;
                    element.text = "function change() { CreateMap(); addPin(); }";
                    head.AppendChild(scriptEl);
                    browser.Document.InvokeScript("change");
                }
                catch (Exception ex)
                {
                    System.Diagnostics.Debug.WriteLine("Exception "  + ex.Message);
                }
            }


            var pane = new DockableControlPane();
            if (bBrowser)
            {
                pane = ultraDockManager1.PaneFromControl(browser);
            }
            else
            {
                pane = ultraDockManager1.PaneFromControl(ultraLabel1);
            }
            if (pane != null)
            {
                System.Diagnostics.Debug.WriteLine("show pane.Parent");
                //pane.Parent.Show();
                pane.Show();
            }   

            var tab = ultraTabbedMdiManager1.ActiveTab;
            if (tab != null)
            {
                System.Diagnostics.Debug.WriteLine("show ActiveTAB");
                tab.Show();               
                
            }
        }

        private void ultraButtonClose_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("ultraButtonClose_Click");
            var pane = new DockableControlPane();
            if (bBrowser)
            {
                pane = ultraDockManager1.PaneFromControl(browser);
            }
            else
            {
                pane = ultraDockManager1.PaneFromControl(ultraLabel1);
            }

            if (pane != null)
            {
                System.Diagnostics.Debug.WriteLine("close pane.Parent");
                //pane.Parent.Close();
                pane.Close();

            }
            var tab = ultraTabbedMdiManager1.ActiveTab;
            if (tab != null)
            {
                System.Diagnostics.Debug.WriteLine("close ActiveTAB");
                tab.Close();
            }
        }

        private void ultraButtonShow_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("ultraButtonShow_Click");
            var pane = new DockableControlPane();
            if (bBrowser)
            {
                pane = ultraDockManager1.PaneFromControl(browser);
            }
            else
            {
                pane = ultraDockManager1.PaneFromControl(ultraLabel1);
            }
            if (pane != null)
            {
                System.Diagnostics.Debug.WriteLine("show pane.Parent");
                //pane.Parent.Show();
                pane.Show();
            }             

            var tab = ultraTabbedMdiManager1.ActiveTab;
            if (tab != null)
            {
                System.Diagnostics.Debug.WriteLine("show ActiveTAB");
                tab.Show();
            }
        }

       
    }
}
